from sqlalchemy import create_engine
from ipc.validator.dataset_metadata_validator import check_datasets_in_repo_for_errors
from ipc.validator.sample_metadata_validator import check_samples_in_repo_for_errors
from ipc.validator.settings import DB_NAME, TABLE, REPOS_FOR_DATASET_LEVEL_VALIDATION, REPOS_FOR_SAMPLE_LEVEL_VALIDATION
import traceback as tb

if __name__ == '__main__':
    # Run the error collection routine
    try:
        # # Get the compiled error table.
        # compiled_error_df = check_datasets_in_repo_for_errors(REPOS_FOR_DATASET_LEVEL_VALIDATION)
        # # Create an SQLAlchemy connection to an SQLite object with name: DB_NAME
        # engine = create_engine(f'sqlite:///ipc/validator/{DB_NAME}')
        # conn = engine.connect()
        # if not compiled_error_df.empty:
        #     # If the DB exists, append to the table.
        #     compiled_error_df.to_sql(TABLE, conn, if_exists='append', chunksize=1000)
        #     print(f'Errors added to table: {TABLE}\nDB: {DB_NAME}')
        # else:
        #     print(f'Error compiling errors')
        # conn.close()
        compiled_errors = check_samples_in_repo_for_errors(REPOS_FOR_SAMPLE_LEVEL_VALIDATION)
        print(compiled_errors.head())
        engine = create_engine(f'sqlite:///ipc/validator/{DB_NAME}')
        conn = engine.connect()
        if not compiled_errors.empty:
            # If the DB exists, append to the table.
            compiled_errors.to_sql(TABLE, conn, if_exists='append', chunksize=1000)
            print(f'Errors added to table: {TABLE}\nDB: {DB_NAME}')
        else:
            print(f'Error compiling errors')
        conn.close()
    except Exception as e:
        print(tb.format_exc())
